import { type Selector } from '@reduxjs/toolkit';
import { type ComputedRef, type DeepReadonly, type Ref } from 'vue';
export declare const select: CreateComputedSelector;
export type SelectorResultArray<Selectors extends SelectorArray> = ExtractReturnType<Selectors>;
export type SelectorArray = ReadonlyArray<Selector>;
type ExtractReturnType<T extends readonly UnknownFunction[]> = {
    [index in keyof T]: T[index] extends T[number] ? ReturnType<T[index]> : never;
};
type UnknownFunction = (...args: any[]) => any;
export interface CreateComputedSelector {
    <Result, State = unknown>(sel: (state: State) => Result): (store: Readonly<Ref<DeepReadonly<State>>>) => ComputedRef<Result>;
    /** For Multiple selectors */
    <Selectors extends SelectorArray, Result, State = unknown>(...items: [...Selectors, (...args: [State, ...SelectorResultArray<Selectors>]) => Result]): (store: Readonly<Ref<DeepReadonly<State>>>) => ComputedRef<Result>;
}
export {};
